"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
function wrap(formatter, dst) {
    return (results) => {
        const output = formatter(results);
        if (dst) {
            fs_1.default.writeFileSync(dst, output, "utf-8");
        }
        else {
            process.stdout.write(output);
        }
    };
}
function getFormatter(formatters) {
    const fn = formatters.split(",").map(cur => {
        const [name, dst] = cur.split("=", 2);
        const moduleName = name.replace(/[^a-z]+/g, "");
        const formatter = require(`../formatters/${moduleName}`);
        return wrap(formatter, dst);
    });
    return (report) => {
        fn.forEach((formatter) => formatter(report.results));
    };
}
exports.getFormatter = getFormatter;
