import { Source } from "../context";
import { MetaTable } from "../meta";
import { Plugin } from "../plugin";
import { ConfigData } from "./config-data";
import { Severity } from "./severity";
interface Transformer {
    pattern: RegExp;
    fn: (filename: string) => Source[];
}
export declare class Config {
    private config;
    private configurations;
    protected metaTable: MetaTable;
    protected plugins: Plugin[];
    protected transformers: Transformer[];
    protected rootDir: string;
    static empty(): Config;
    static fromObject(options: ConfigData): Config;
    static fromFile(filename: string): Config;
    static defaultConfig(): Config;
    constructor(options?: ConfigData);
    init(): void;
    merge(rhs: Config): Config;
    private extendConfig;
    getMetaTable(): MetaTable;
    static expandRelative(src: string, currentPath: string): string;
    get(): ConfigData;
    getRules(): Map<string, [Severity, any]>;
    getPlugins(): Plugin[];
    private loadPlugins;
    private loadConfigurations;
    transform(filename: string): Source[];
    private findTransformer;
    private precompileTransformers;
    protected findRootDir(): string;
}
export {};
