"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function sliceSize(size, begin, end) {
    if (typeof size !== "number") {
        return size;
    }
    if (typeof end !== "number") {
        return size - begin;
    }
    if (end < 0) {
        end = size + end;
    }
    return Math.min(size, end - begin);
}
function sliceLocation(location, begin, end) {
    if (!location)
        return null;
    const size = sliceSize(location.size, begin, end);
    return {
        filename: location.filename,
        offset: location.offset + begin,
        line: location.line,
        column: location.column + begin,
        size,
    };
}
exports.sliceLocation = sliceLocation;
