import { HtmlElement } from "../dom";
import { AttributeData } from "../parser";
export declare type ProcessAttributeCallback = (attr: AttributeData) => Iterable<AttributeData>;
export declare type ProcessElementCallback = (node: HtmlElement) => void;
export interface SourceHooks {
    processAttribute?: ProcessAttributeCallback;
    processElement?: ProcessElementCallback;
}
export interface Source {
    data: string;
    filename: string;
    line: number;
    column: number;
    originalData?: string;
    hooks?: SourceHooks;
}
