"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dynamic_value_1 = require("./dynamic-value");
class Attribute {
    constructor(key, value, keyLocation, valueLocation, originalAttribute) {
        this.key = key;
        this.value = value;
        this.keyLocation = keyLocation;
        this.valueLocation = valueLocation;
        this.originalAttribute = originalAttribute;
        if (typeof this.value === "undefined") {
            this.value = null;
        }
    }
    get isStatic() {
        return !this.isDynamic;
    }
    get isDynamic() {
        return this.value instanceof dynamic_value_1.DynamicValue;
    }
    valueMatches(pattern, dynamicMatches = true) {
        if (this.value instanceof dynamic_value_1.DynamicValue) {
            return dynamicMatches;
        }
        if (pattern instanceof RegExp) {
            return this.value.match(pattern) !== null;
        }
        else {
            return this.value === pattern;
        }
    }
}
exports.Attribute = Attribute;
