import { Location } from "../context";
import { NodeType } from "./nodetype";
export declare function reset(): void;
export declare class DOMNode {
    readonly nodeName: string;
    readonly nodeType: NodeType;
    readonly childNodes: DOMNode[];
    readonly location: Location;
    readonly unique: number;
    private disabledRules;
    constructor(nodeType: NodeType, nodeName: string, location?: Location);
    readonly textContent: string;
    append(node: DOMNode): void;
    isRootElement(): boolean;
    readonly firstChild: DOMNode;
    readonly lastChild: DOMNode;
    disableRule(ruleId: string): void;
    enableRule(ruleId: string): void;
    ruleEnabled(ruleId: string): boolean;
}
