"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const domnode_1 = require("./domnode");
const dynamic_value_1 = require("./dynamic-value");
const nodetype_1 = require("./nodetype");
const TEXT_NODE_NAME = "#text";
class TextNode extends domnode_1.DOMNode {
    constructor(text, location) {
        super(nodetype_1.NodeType.TEXT_NODE, TEXT_NODE_NAME, location);
        this.text = text;
    }
    get textContent() {
        return this.text.toString();
    }
    get isStatic() {
        return !this.isDynamic;
    }
    get isDynamic() {
        return this.text instanceof dynamic_value_1.DynamicValue;
    }
}
exports.TextNode = TextNode;
