import { Config, ConfigData, ConfigLoader } from "./config";
import { Source } from "./context";
import { SourceHooks } from "./context/source";
import { EventDump, TokenDump } from "./engine";
import { Parser } from "./parser";
import { Report } from "./reporter";
import { RuleDocumentation } from "./rule";
declare class HtmlValidate {
    private globalConfig;
    protected configLoader: ConfigLoader;
    constructor(config?: ConfigData);
    validateString(str: string, hooks?: SourceHooks): Report;
    validateSource(source: Source): Report;
    validateFile(filename: string): Report;
    dumpTokens(filename: string): TokenDump[];
    dumpEvents(filename: string): EventDump[];
    dumpTree(filename: string): string[];
    getRuleDocumentation(ruleId: string, config?: Config, context?: any): RuleDocumentation;
    getParserFor(source: Source): Parser;
    getConfigFor(filename: string): Config;
    flushConfigCache(filename?: string): void;
}
export default HtmlValidate;
