import { TokenType } from "./lexer";
interface TokenMatcher {
    type: TokenType;
    location?: any;
    data?: any;
}
declare global {
    namespace jest {
        interface Matchers<R> {
            toBeValid(): R;
            toBeInvalid(): R;
            toBeToken(expected: TokenMatcher): R;
            toHaveError(ruleId: string, message: string): R;
            toHaveErrors(errors: Array<[string, string] | {}>): R;
        }
    }
}
export {};
