import { ConfigData } from "../config";
import { Source } from "../context";
import { EventHandler } from "../event";
import { RuleConstructor } from "../rule";
export interface SchemaValidationPatch {
    properties?: object;
    definitions?: object;
}
export interface Plugin {
    name: string;
    init?: () => void;
    setup?: (source: Source, eventhandler: EventHandler) => void;
    configs: {
        [key: string]: ConfigData;
    };
    rules: {
        [key: string]: RuleConstructor;
    };
    elementSchema?: SchemaValidationPatch;
}
