"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function inAccessibilityTree(node) {
    do {
        const role = node.getAttribute("role");
        const ariaHidden = node.getAttribute("aria-hidden");
        if (role && role.value === "presentation") {
            return false;
        }
        if (ariaHidden && ariaHidden.value === "true") {
            return false;
        }
        node = node.parent;
    } while (!node.isRootElement());
    return true;
}
exports.inAccessibilityTree = inAccessibilityTree;
