"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dom_1 = require("../../dom");
function* processAttribute(attr) {
    if (typeof attr.value === "string" && attr.value.match(/{{.*}}/)) {
        yield Object.assign({}, attr, {
            value: new dom_1.DynamicValue(attr.value),
        });
        return;
    }
    yield attr;
    if (attr.key.startsWith("dynamic-")) {
        yield Object.assign({}, attr, {
            key: attr.key.replace("dynamic-", ""),
            value: new dom_1.DynamicValue(attr.value),
            originalAttribute: attr.key,
        });
    }
}
exports.processAttribute = processAttribute;
